Bug 1318977 (CVE-2016-3190) - CVE-2016-3190 cairo: out of bounds read in fill_xrgb32_lerp_opaque_spans
Summary: CVE-2016-3190 cairo: out of bounds read in fill_xrgb32_lerp_opaque_spans
Keywords:
Status: CLOSED ERRATA
Alias: CVE-2016-3190
Product: Security Response
Classification: Other
Component: vulnerability
Version: unspecified
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Red Hat Product Security
QA Contact:
URL:
Whiteboard: impact=moderate,public=20160310,repor...
Depends On: 1318978
Blocks: 1318980
TreeView+ depends on / blocked
 
Reported: 2016-03-18 10:10 UTC by Andrej Nemec
Modified: 2019-06-08 21:05 UTC (History)
8 users (show)

Fixed In Version: cairo 1.14.2
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2016-09-23 04:34:55 UTC


Attachments (Terms of Use)

Description Andrej Nemec 2016-03-18 10:10:32 UTC
A vulnerability was found in cairo. A maliciously crafted file can cause out of bounds read in fill_xrgb32_lerp_opaque_spans function in cairo, thus crashing the software.

Upstream fix:

https://cgit.freedesktop.org/cairo/patch/src/cairo-image-compositor.c?id=5c82d91a5e15d29b1489dcb413b24ee7fdf59934

References:

http://seclists.org/oss-sec/2016/q1/675

External references:

https://mail.gnome.org/archives/gnome-announce-list/2015-March/msg00047.html

Comment 1 Andrej Nemec 2016-03-18 10:11:00 UTC
Created mingw-cairo tracking bugs for this issue:

Affects: epel-7 [bug 1318978]

Comment 3 Doran Moppert 2016-06-06 03:02:06 UTC
Upstream bug:

https://bugs.freedesktop.org/show_bug.cgi?id=89521

Reproducer is available there.

Note last update in comment #2:

> However, the original author of that patch (ilia.softway@gmail.com) has
> expressed doubts that this change fully fixes the problem and he is now using
> an additional patch to cell_list_add_subspan() in cairo-tor_scan-converter.c.
>
> Therefore, I think it is best to leave this bug open until the root cause is
> fully understood.

Comment 5 Doran Moppert 2016-07-19 07:39:39 UTC
The window of affected versions is somewhere after 1.11.2 until the fix was included in 1.14.2.  This leaves epel-7/mingw-cairo and rhel-7.1/cairo affected;  all other versions are either prior to the vulnerable code's introduction or (rhel-7.2, fedora, epel/cairo) include the fix.

Comment 8 Doran Moppert 2016-09-23 04:34:55 UTC
This CVE was previously addressed in Red Hat Enterprise Linux 7 in the rebase to 1.14.2:

https://rhn.redhat.com/errata/RHBA-2015-2116.html


Note You need to log in before you can comment on or make changes to this bug.